unit uKasiski;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils;

type
  TForm1 = class(TForm)
    mEin: TMemo;
    bAnalysiere: TButton;
    mAus: TMemo;
    bKasiski: TButton;
    eLaenge: TEdit;
    lLaenge: TLabel;
    bLoesche: TButton;
    procedure bAnalysiereClick(Sender: TObject);
    procedure bKasiskiClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bAnalysiereClick(Sender: TObject);
var
  text  : string;
  n,i   : integer;
  Ind,h : real;
  z     : array[0..255] of byte;
begin
  // Eingabe
  text := mEin.Text;

  // Vorbereitungen
  for i := 0 to 255 do z[i] := 0;

  // Zhlen
  for i := 0 to Length(text) do inc(z[ord(upcase(text[i]))]); // upcase !

  // Buchstaben zhlen
  n := 0;
  for i := 65 to 90 do n := n + z[i]; // A .. Z

  // Koinzidenzindex Ind berechnen
  Ind := 0;
  for i := 65 to 90 do Ind := Ind + sqr(z[i]/n);

  // Schlsselwortlnge h berechnen
  h := 0.0377*n/(Ind*(n-1)-0.0385*n+0.0762);

  // Ausgabe
  mAus.Lines.Add('Koinzidenz-Index = '+FloatToStr(Ind));
  mAus.Lines.Add('h = '+FloatToStr(h));
end;

procedure TForm1.bKasiskiClick(Sender: TObject);
var
  text,wort,rest : string;
  pos1,pos2,laenge,i : integer;
begin
  // Eingabe
  text := mEin.Text;
  // Zeilensprnge rauswerfen
  while pos(#10,text) > 0 do delete(text,pos(#10,text),1);
  while pos(#13,text) > 0 do delete(text,pos(#13,text),1);

  laenge := StrToInt(eLaenge.text);
  for i := 1 to Length(text)- laenge do
  begin
    // wort an Position pos1 whlen
    pos1 := i; wort := copy(text,pos1,laenge);
    // wort im Rest suchen
    pos2 := PosEx(wort,text,pos1+1); // PosEx aus StrUtils
    // bei Wiederholung Positionen ausgeben
    if  pos2 > 0
    then
      mAus.Lines.Add(wort+' '+IntToStr(pos1)+ ' ' + IntToStr(pos2) +
                     '  '+ IntToStr(pos2-pos1));
  end;
end;


procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAus.Clear;
end;

end.
